//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_UAIL_APP_DEFINITIONS__
#define __EZ_UAIL_APP_DEFINITIONS__

//############################################################################
#include "ez_uail.hpp"

//############################################################################
class ez_uail_app : public ez_uail
{
public:
    ez_uail_app();
    //------------------------------------------------------------------------
virtual
   ~ez_uail_app();
    //------------------------------------------------------------------------
    void   apply_wave_offsets          (string file_name);
    void   overwirte_wave_offsets      (string file_name);
    void   invert_wave                 (string file_name);
    //------------------------------------------------------------------------
    void   split_wave_xyrgbi           (string file_name);
    //------------------------------------------------------------------------
    void   join_xyrgbi_waves           (string file_name_xy,
                                        string file_name_r,
                                        string file_name_g,
                                        string file_name_b,
                                        string file_name_i,
                                        string file_name_out
                                       );
    //------------------------------------------------------------------------
    void   load_frame_effects          ();
    void   load_frame_set_effects      ();
    void   call_frame_effect           (string name     );
    void   call_frame_set_effect       (string name     );
    //------------------------------------------------------------------------
    void   load_effects()
            {
                load_frame_effects    ();
                load_frame_set_effects();
            }
    //------------------------------------------------------------------------
    u_char black_threshold         ;
    //------------------------------------------------------------------------
    int    wave_sample_rate        ,
           lit_dwell_overhang      ,
           output_bmp_size         ,
          *wave_offsets            ;

    float  lit_distance_delta_max  ,
           blank_distance_delta_max,
           longest_dwell_microsec  ,
           insignificant_distance  ,
           zero_angle_tolerance    ,
           recolor_span_factor     ,
           rendered_arc_angle      , // in degrees
           frames_per_second       ,
           still_frame_duration    ;

    bool   auto_scale_dxf          ,
           maintain_dxf_origin     ,
           black_dwell_points      ,
           auto_flatten_z          ,
           expensive_minimize      ,
           invert_wave_output      ,
           auto_optimize           ,
           no_black_match          ,
           dumb_file_format        ;
    //------------------------------------------------------------------------
    vector<string>                    frame_effect_names     ,
                                      frame_set_effect_names ;
    //------------------------------------------------------------------------
    vector<ez_uail_frame_effect>      frame_effects          ;
    vector<ez_uail_frame_set_effect>  frame_set_effects      ;
    //------------------------------------------------------------------------
};

//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
